/*
Arquivo:	main.c
Descricao:	Programa para computar FFT a partir de dados no dominio do
		tempo ou IFFT a partir das partes reais e imaginarias no
		dominio da frequencia.
Autor:		Joao Dovicchi
Data:		05/2005
*/ 


#include "dft.h"

int isign, db;
long nn;
char fname[30];
double *data;

void main(int argc,char **argv)
{
	int i;

	printf(" Programa dft\tJoao Dovicchi<dovicchi@inf.ufsc.br>\n");
	printf("(c) 2005 - RExLab - INE - CTC - UFSC\n");
	printf("Versao: %s\t %s\n", VERSAO, DATA);


	if(argc < 2)
	{
		uso(0);
		exit(1);
	}
	for(i=1;i<argc;i++)
	{
		if(*argv[i]=='-')
		{
			switch(argv[i][1])
			{
				case 'f':isign=1;break;
				case 'i':isign=-1;break;
				case 'l':db=0;break;
				case 'n':db=1;break;
				case 'h':help();exit(0);
				default: uso(1);
			}
		}
		else strcpy(fname,argv[i]);
	}
	
	if( isign == 0 ) isign = 1;

	read_fft();
	real_fft();
	save_fft();
}

