/* 	
Arquivo:	norm.c
Descricao: 	Rotina para normalizar os dados de fft ou inverter caso
		os dados de entrada para ifft estejam normalizados.
		A rotina toma os valores absolutos da transformada e 
		divide os dados pelo maior componente, transformando-os
		em dB aplicando 20*log(x(n)/x_max) para cada n.
Autor:		Joao Dovicchi
Data:		05/05
*/


#include "dft.h"

extern long nn;
extern double *data;

void norm_db()
{
	double x_max;
	int k;

	x_max=fabs(data[0]);
	
	for( k=0; k<nn-1; k++)		/* escolhemos o maior valor abs*/
	{
		if( x_max < fabs(data[k+1]) )
		{
			x_max = fabs(data[k+1]);
		}
	}
	
	for( k=0; k<nn; k++)		/* transformamos os valores em dB */
	{
		if( fabs(data[k]) < 0.001 )
		{
			data[k] = 0.001; 
		}
		data[k] = 20.0 * log( fabs(data[k])/x_max );
	}
}

