/* 	
Arquivo:	real.c
Autor:		Joao Dovicchi
Data:		05/05
*/


#include "dft.h"

extern int isign;
extern long nn;
extern double *data;

void real_fft()
{
	long i, i1, i2, i3, i4, np3;
	double wtemp, wr, wpr, wpi, wi, theta;
	float c1=0.5, c2, h1r, h1i, h2r, h2i;
	
	theta= pi/(double) (nn>>1);
	if( isign == 1 )
	{
		c2 = -0.5;
		nn = nn>>1;
		isign = 1;
		four1();
	}
	else
	{
		c2 = 0.5;
		theta = -theta;
	}
	wtemp = sin( 0.5*theta );
	wpr = -2.0 * wtemp * wtemp;
	wpi = sin( theta );
	wr = 1.0 + wpr;
	wi = wpi;
	np3 = nn + 3;
	for( i=2; i<=(nn>>2); i++)
	{
		i4 = 1 + (i3 = np3 -(i2=1 + (i1 = i+i-1)));
		
		h1r = c1 * (data[i1] + data[i3]);
		h1i = c1 * (data[i2] - data[i4]);
		h2r = -c2* (data[i2] + data[i4]);
		h2i = c2 * (data[i1] - data[i3]);
		
		data[i1] = h1r + wr*h2r - wi*h2i;
		data[i2] = h1i + wr*h2i + wi*h2r;
		data[i3] = h1r - wr*h2r + wi*h2i;
		data[i4] =-h1i + wr*h2i + wi*h2r;
		
		wr = (wtemp=wr)*wpr - wi*wpi + wr;
		wi = wi*wpr + wtemp*wpi + wi;
	}
	if( isign == 1)
	{
		data[1] = (h1r=data[1]) + data[2];
		data[2] = h1r - data[2];
	}
	else
	{
		data[1] = c1*(h1r=data[1]) + data[2];
		data[2] = c1*(h1r - data[2]);
		nn = nn>>1;
		isign = -1;
		four1();
	}
}
