/*
Arquivo:	rfft.c
Descricao:	Funcao para ler dados de um arquivo no dominio do tempo
		para computar a transformada direta de Fourier (FFT)
Autor:		Joao Dovicchi
Data:		05/05
*/

#include "dft.h"

extern long nn;
extern double *data;
extern char fname[30];
extern int isign;

FILE *ifp;

void read_fft()
{
        long n=0, i=0;
	char dado[32];
	float db_i, l_i, xn;

		/*******************************/
		/* Conta o numero de elementos */
		/* no arquivo de entrada       */
		/*******************************/
        if( ( ifp = fopen(fname,"r")) != NULL)
	{
		n=0;
		do
		{
			fgets(dado,sizeof(dado)-1,ifp);
     			++n;
   		} 
		while( !feof(ifp));
   		fclose(ifp);
   		n--;
   		printf("Elementos: %ld\n",n);

		/******************************/
		/* Determina se o conjunto de */
		/* amostras tem 2^N elementos */
		/******************************/
		db_i = n/1.0;
        	l_i = log_base_2( db_i );
        	xn = floor( l_i );
        	if ((l_i - xn) != 0)
        	{
                	printf( "Amostra nao tem 2^n elementos!!\n");
			printf( " **** RESULTADOS DEPENDEM DA COERENCIA DOS DADOS ****\n\n" );
        	}

		/**********************************/
		/* Aloca 2*N doubles para data[]  */
		/**********************************/
		if(isign==1)
		{ 		/* alocamos para a fft */
  			data = calloc(2*n,sizeof(double));
		}
		else
		{		/* p/ interpolacao alocamos muito mais */
			data = calloc(8*n,sizeof(double));
		}

		/*******************************/
		/* Passa o numero de elementos */
		/* para a variavel externa nn */
		/*******************************/
		nn = n;
	}
	else
        {
                printf(" Erro de leitura do arquivo.\n\n");
                exit(1);
        }

		/*******************************/
		/* Le os dados do arquivo para */
		/* data[n] (1,2,3,...,nn)   */
		/*******************************/
        ifp = fopen(fname,"r");
        for( i=0; i<n; i++)
        {
               	fscanf( ifp, "%s", dado );
		data[i] =  atof( dado );
        }

	fclose(ifp);

}
