/*
Arquivo:	sfft.c
Descricao:	Funcao para salvar os dados de FFT no arquivo out.dat
Autor:		Joao Dovicchi
Data:		05/05
*/

#include "dft.h"

extern int isign, db;
extern  long nn;
extern double *data;

FILE *ofp;

void save_fft()
{
	long k;

	printf ("isign = %d\n", isign);
	ofp=fopen("out.dat","w");
	if(isign==1)
	{
		if(db == 1)
		{
			norm_db();
			for (k=0; k<nn; k+=2)
			{
                		fprintf(ofp, "%f %f\n", data[k], data[k+1]);
			}
		}
		else
		{
			for (k=0; k<nn; k+=2)
			{
				if(data[k]<0.0) data[k]=0.0;
				if(data[k+1]>0.0) data[k+1]=0.0;
                		fprintf(ofp, "%f %f\n", data[k], data[k+1]);
			}
		}
	}
	else
	{
		interpol();
		for (k=0; k<nn; ++k)
		{
               		fprintf(ofp, "%f\n", 4*data[k]/(double) nn );
		}
	}
       	fclose(ofp);
}
